/*-
 * ============LICENSE_START=======================================================
 * ONAP - SO
 * ================================================================================
 * Copyright (C) 2017 AT&T Intellectual Property. All rights reserved.
 * ================================================================================
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * ============LICENSE_END=========================================================
 */

package org.openecomp.mso.client.dmaap;

public interface Consumer {

	/**
	 * Should this consumer continue to consume messages from the topic?
	 * @return
	 */
	public boolean continuePolling();
	/**
	 * Process a message from a DMaaP topic
	 * 
	 * @param message
	 * @throws Exception
	 */
	public void processMessage(String message) throws Exception;
	/**
	 * Has the request been accepted by the receiving system?
	 * Should the consumer move to processing messages?
	 * 
	 * @param message
	 * @return
	 */
	public boolean isAccepted(String message);
	/**
	 * The request id to filter messages on
	 * @return
	 */
	public String getRequestId();
	/**
	 * Logic that defines when the consumer should stop processing messages
	 */
	public void stopProcessingMessages();
}
